﻿Imports System
Imports System.Data
Imports System.Data.OleDb
Imports Syncfusion.JavaScript.Models
Imports System.Configuration
Imports System.Data.SqlClient
Public Class MyTeam
    Inherits System.Web.UI.Page

    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Dim sMessage As String
        Dim prmTeam As String

        'get parameter
        prmTeam = Request.QueryString("MyTeam")
        If IsNothing(prmTeam) Then
            Accordion1.Visible = False
            Exit Sub
        Else
            If Not prmTeam = "" Then
                Accordion1.Visible = True
            Else
                Accordion1.Visible = False
                Exit Sub
            End If
        End If

        ProcessTeam(prmTeam)

        'DropDownList1.Width = 320
        Grid3.Width = 452
        Grid6.Model.GridLines = Syncfusion.JavaScript.GridLines.Horizontal
        Grid3.Model.GridLines = Syncfusion.JavaScript.GridLines.Horizontal
        cbCompetitions.Attributes.Add("onclick", "return false;")

        'Team Statistics
        SqlDataSourceStats.SelectCommand =
           "Select '1. All Matches' AS M_Type, MAX(TScore_Score) AS MAX_C, MIN(TScore_Score) AS MIN_C, AVG(TScore_Score) AS AVG_C " _
         + "From TeamScores " _
         + "Where TScore_FixtureType In ('L','C') " _
         + "And TScore_TeamName =  '" + prmTeam.ToString + "' " _
         + "And TScore_Score > 10 " _
         + "UNION " _
         + "Select '2. League Matches' AS M_Type, MAX(TScore_Score) AS MAX_C, MIN(TScore_Score) AS MIN_C, AVG(TScore_Score) AS AVG_C " _
         + "From TeamScores " _
         + "Where TScore_FixtureType = 'L' " _
         + "And TScore_TeamName =  '" + prmTeam.ToString + "' " _
         + "And TScore_Score > 10 " _
         + "UNION " _
         + "Select '3. Competition Matches' AS M_Type, MAX(TScore_Score) AS MAX_C, MIN(TScore_Score) AS MIN_C, AVG(TScore_Score) AS AVG_C " _
         + "From TeamScores " _
         + "Where TScore_FixtureType = 'C' " _
         + "And TScore_TeamName =  '" + prmTeam.ToString + "' " _
         + "And TScore_Score > 10 " _
         + "Order By 1 ASC"

    End Sub
    Protected Function StatisticsExist() As Boolean
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sql As String
        Dim bResult As Boolean
        Dim iCount As Integer = 0

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        sql = "SELECT COUNT(*) FROM TeamStatistics"
        myCommand.CommandText = sql
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            iCount = myReader.Item(0)
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()
        If iCount > 0 Then
            bResult = True
        Else
            bResult = False
        End If
        Return bResult

    End Function
    'Protected Function LeagueTablesExist() As Boolean
    '    Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
    '    Dim conn As New OleDbConnection
    '    Dim myReader As OleDbDataReader
    '    Dim myCommand As New OleDbCommand
    '    Dim sql As String
    '    Dim bResult As Boolean
    '    Dim iCount As Integer = 0

    '    conn.ConnectionString = AccessConnect
    '    conn.Open()
    '    myCommand.Connection = conn
    '    sql = "SELECT COUNT(*) FROM LeagueTables"
    '    myCommand.CommandText = sql
    '    myReader = myCommand.ExecuteReader
    '    While myReader.Read()
    '        iCount = myReader.Item(0)
    '    End While
    '    myReader.Close()
    '    myReader = Nothing
    '    myCommand.Dispose()
    '    conn.Close()
    '    conn.Dispose()
    '    If iCount > 0 Then
    '        bResult = True
    '    Else
    '        bResult = False
    '    End If
    '    Return bResult

    'End Function

    Protected Sub ProcessTeam(ByVal myTeam As String)
        Dim sTeam As String = ""
        Dim sSQL As String = ""
        Dim bComps As Boolean = False
        Dim iPk_Team As Integer

        If IsNothing(myTeam) Then
            Accordion1.Visible = False
            Exit Sub
        Else
            Accordion1.Visible = True
        End If

        sTeam = myTeam
        iPk_Team = GetTeamId(sTeam)

        sSQL = "SELECT PScore_Name, Alley_Name, PScore_Date, PScore_Score " _
             + "FROM PlayerScores, Alleys " _
             + "WHERE PSCore_Team = " + iPk_Team.ToString + " " _
             + "AND PScore_Alley = Pk_Alley " _
             + "AND PScore_Score = (SELECT MAX(PScore_Score) FROM PlayerScores WHERE PScore_Team = " + iPk_Team.ToString + ") " _
             + "UNION " _
             + "SELECT PScore_Name, Alley_Name, PScore_Date, PScore_Score " _
             + "FROM PlayerScoresFemale, Alleys " _
             + "WHERE PSCore_Team = " + iPk_Team.ToString + " " _
             + "AND PScore_Alley = Pk_Alley " _
             + "AND PScore_Score = (SELECT MAX(PScore_Score) FROM PlayerScoresFemale WHERE PScore_Team = " + iPk_Team.ToString + ") " _
             + "ORDER BY PScore_Score DESC"
        SqlDataSource5.SelectCommand = sSQL
        Grid5.DataBind()
        Grid5.Visible = True

        sSQL = "SELECT LT.LT_Division, LT.LT_Order, T.Team_Contact, T.Team_Phone, T.Team_Night, T.Team_EMail, A.Alley_Name, A.Alley_Phone " _
             + "FROM LeagueTables LT , Teams T, Alleys A " _
             + "WHERE LT_TeamName = '" + sTeam + "' " _
             + "AND   LT.PK_Team = T.Pk_Team " _
             + "AND   T.Fk_Alley = A.Pk_Alley"
        SqlDataSource4.SelectCommand = sSQL
        Grid4.DataBind()
        Grid4.Visible = True


        If StatisticsExist() Then
            AccordionItem1.Text = sTeam + GetNextMatch(sTeam)
            SqlDataSource3.SelectCommand = "SELECT T.Team_Name, L.LT_Games, L.LT_Won, L.LT_Drawn, L.LT_Lost, L.LT_Points, TS.TS_Low, TS.TS_High, TS.TS_Average 
                     FROM LeagueTables L , TeamStatistics TS , Teams T
                     WHERE L.Pk_Team = T.Pk_Team
                     AND L.Pk_Team = TS_TeamKey"
        Else
            AccordionItem1.Text = sTeam + " - no scores recorded yet. " + GetNextMatch(sTeam)
            SqlDataSource3.SelectCommand = "SELECT T.Team_Name, L.LT_Games, L.LT_Won, L.LT_Drawn, L.LT_Lost, L.LT_Points
                     FROM LeagueTables L , Teams T
                     WHERE L.Pk_Team = T.Pk_Team"
        End If
        Grid3.DataBind()
        SqlDataSource3.FilterExpression = "Team_Name = " + "'" + sTeam + "'"
        Grid3.Width = 768
        Grid3.Visible = True

        For iCount As Integer = 0 To 3
            cbCompetitions.Items(iCount).Selected = GetCompetitions(iCount, sTeam)
            If cbCompetitions.Items(iCount).Selected = True Then
                bComps = True
            End If
        Next

        cbCompetitions.Visible = True
        cbCompetitions.Height = 75
        GetFixturesScoresAndPlayerScores(sTeam)

        Grid6.StackedHeaderRows(0).StackedHeaderColumn(0).HeaderText = sTeam.ToString + " Matches: " + GetRecentForm(sTeam)
        If Grid6.StackedHeaderRows(0).StackedHeaderColumn(0).HeaderText.Contains("<sup>") Then
            'do nothing
        Else
            Grid6.StackedHeaderRows(0).StackedHeaderColumn(0).HeaderText = sTeam.ToString + " Matches, No recent form to display."
        End If

        Grid5.StackedHeaderRows(0).StackedHeaderColumn(0).HeaderText = "League & Major Competitions Highest Scorers for: " + sTeam.ToString + " (ordered by top scores first)"

    End Sub
    Function GetNextMatch(ByVal sTeam As String) As String
        Dim sResult As String = ""
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sSql As String
        Dim sVersus As String
        Dim sType As String
        Dim iCount As Integer = 0
        Dim oDate As Date
        Dim sDate As String

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        sSql = "SELECT Fixture_HomeName, Fixture_AwayName, Fixture_AlleyName, Fk_Date, Fixture_Type " _
             + "FROM Fixtures " _
             + "WHERE Fixture_Status = 'N' " _
             + "AND Fk_Date >= " + FormatDateForDatabaseQuery(Today()) + " " _
             + "AND ((Fixture_HomeName = '" + sTeam + "') " _
             + "OR   (Fixture_AwayName = '" + sTeam + "')) " _
             + "ORDER BY Fk_Date ASC"

        myCommand.CommandText = sSql
        myReader = myCommand.ExecuteReader
        If myReader.HasRows Then
            While myReader.Read()
                iCount = iCount + 1
                If iCount < 2 Then
                    oDate = myReader.Item(3)
                    sDate = oDate.DayOfWeek.ToString + ", " + oDate.Day.ToString + "-" + GetMonthText(oDate.Month) + "-" + oDate.Year.ToString
                    If myReader.Item(0).ToString = sTeam Then
                        sVersus = " versus " + myReader.Item(1).ToString + ")"
                    Else
                        sVersus = " versus " + myReader.Item(0).ToString + ")"
                    End If

                    If myReader.Item(4).ToString = "L" Then
                        sType = "League"
                    Else
                        sType = "Competition"
                    End If
                    sResult = " (next match - " + sType.ToString + "... on " + sDate.ToString + " at " + myReader.Item(2).ToString + sVersus
                End If
            End While
        Else
            sResult = ""
        End If
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()

        Return sResult

    End Function
    Protected Function GetRecentForm(ByVal thisTeam As String) As String
        Dim sReturn As String = "<font size=1 style=normal color=yellow>Recent Form (League Matches only) : <span>"
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sSql As String

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        sSql = "SELECT Fixture_HomeName, Fixture_HScore,Fixture_AwayName,Fixture_AScore " _
             + "FROM Fixtures " _
             + "WHERE Fixture_Type = 'L' " _
             + "AND Fixture_HScore > 50 " _
             + "AND Fixture_AScore > 50 " _
             + "AND ((Fixture_HomeName = '" + thisTeam + "') " _
             + "OR   (Fixture_AwayName = '" + thisTeam + "')) " _
             + "ORDER BY Fk_Date ASC"

        myCommand.CommandText = sSql
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            If myReader.Item(0).ToString = thisTeam Then
                If myReader.Item(1) > myReader.Item(3) Then
                    sReturn = sReturn + "W<sup>H </sup>"
                End If
                If myReader.Item(1) = myReader.Item(3) Then
                    sReturn = sReturn + "D<sup>H </sup>"
                End If
                If myReader.Item(1) < myReader.Item(3) Then
                    sReturn = sReturn + "L<sup>H </sup>"
                End If
            Else
                If myReader.Item(3) > myReader.Item(1) Then
                    sReturn = sReturn + "W<sup>A </sup>"
                End If
                If myReader.Item(3) = myReader.Item(1) Then
                    sReturn = sReturn + "D<sup>A </sup>"
                End If
                If myReader.Item(3) < myReader.Item(1) Then
                    sReturn = sReturn + "L<sup>A </sup>"
                End If
            End If
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()

        sReturn = sReturn + "</span></font>" + CountByes(thisTeam)

        Return sReturn

    End Function
    Protected Function CountByes(ByVal thisTeam As String) As String
        Dim sResult As String = ""
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sql As String
        Dim iCount As Integer = 0

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        sql = "SELECT COUNT(*) FROM Fixtures WHERE Fixture_Status = 'B' " + " " _
            + "AND (Fixture_HomeName = '" + thisTeam + "' " _
            + "OR   Fixture_AwayName = '" + thisTeam + "') " _
            + "AND Fixture_Type = 'L'"

        myCommand.CommandText = sql
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            iCount = myReader.Item(0)
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()
        If iCount > 0 Then
        End If

        Select Case iCount
            Case 0
                sResult = ""
            Case 1
                sResult = " - (1 League Bye recorded)"
            Case Else
                sResult = " - (" + iCount.ToString + " League Byes recorded)"
        End Select
        Return sResult

    End Function
    Protected Sub GetFixturesScoresAndPlayerScores(ByVal sThisTeam As String)
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sSQL As String
        Dim dt As New DataTable()
        Dim sFixtureType As String = ""
        Dim sPlayerScores As String = ""
        Dim sOnline As String = ""
        Dim iTeamKey As Integer
        Dim iHScore As Integer = 0
        Dim iAScore As Integer = 0


        dt.Columns.AddRange(New DataColumn() {New DataColumn("FixtureType", GetType(String)),
                                              New DataColumn("FixtureAlleyName", GetType(String)),
                                              New DataColumn("FixtureDate", GetType(Date)),
                                              New DataColumn("FixtureHomeName", GetType(String)),
                                              New DataColumn("FixtureHomeScore", GetType(Integer)),
                                              New DataColumn("FixtureAwayName", GetType(String)),
                                              New DataColumn("FixtureAwayScore", GetType(Integer)),
                                              New DataColumn("FixturePlayers", GetType(String)),
                                              New DataColumn("FixtureOnline", GetType(String))})

        sSQL = "SELECT Fixture_Cup, Fixture_Round, Fixture_AlleyName, Fk_Date, Fk_HomeKey, Fixture_HomeName, Fixture_HScore, Fk_AwayKey, Fixture_AwayName, Fixture_AScore, Fixture_Online, Fixture_Status " _
             + "FROM Fixtures WHERE Fixture_Status IN ('B','N','S') " _
             + "AND ((Fixture_HomeName = '" + sThisTeam + " ') " _
             + "OR (Fixture_AwayName = '" + sThisTeam + "')) " _
             + "ORDER BY Fk_Date ASC"
        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        myCommand.CommandText = sSQL
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            sOnline = ""
            sFixtureType = ""
            sPlayerScores = ""

            If myReader.Item(11) = "B" Then
                sFixtureType = "Bye"
                iHScore = GetByeScore("H", myReader.Item(5), myReader.Item(8))
                iAScore = GetByeScore("A", myReader.Item(5), myReader.Item(8))
            Else
                sFixtureType = GetFixtureType(myReader.Item(0), myReader.Item(1))
                iHScore = myReader.Item(6)
                iAScore = myReader.Item(9)
            End If
            If myReader.Item(11) <> "N" Then
                If myReader.Item(10) = "Y" Then
                    sOnline = "Yes"
                Else
                    sOnline = "No"
                End If
                If myReader.Item(5) = sThisTeam Then
                    iTeamKey = myReader.Item(4)
                Else
                    iTeamKey = myReader.Item(7)
                End If
                sPlayerScores = GetPlayerScores(myReader.Item(3), iTeamKey)
            Else
                sOnline = ""
                sPlayerScores = ""
            End If
            dt.Rows.Add(sFixtureType, myReader.Item(2), myReader.Item(3), myReader.Item(5), iHScore, myReader.Item(8), iAScore, sPlayerScores, sOnline)
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()

        Grid6.DataSource = dt
        Grid6.DataBind()
        Grid6.Visible = True
        Grid6.AllowFiltering = True
        Grid6.AllowTextWrap = True

    End Sub
    Protected Function GetByeScore(ByVal sType As String, ByVal sHomeTeam As String, ByVal sAwayTeam As String) As Integer
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sSQL As String
        Dim iReturn As Integer

        If sType = "H" Then
            sSQL = "SELECT HScore_Homepoints " _
             + "FROM ScoreHistory WHERE HScore_Status IN ('B') " _
             + "AND ((HScore_HomeName = '" + sHomeTeam + " ') " _
             + "AND (HScore_AwayName = '" + sAwayTeam + "'))"
        Else
            sSQL = "SELECT HScore_Awaypoints " _
             + "FROM ScoreHistory WHERE HScore_Status IN ('B') " _
             + "AND ((HScore_HomeName = '" + sHomeTeam + " ') " _
             + "AND (HScore_AwayName = '" + sAwayTeam + "'))"
        End If

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        myCommand.CommandText = sSQL
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            iReturn = myReader.Item(0)
        End While

        If iReturn = 0 Then
            iReturn = 1
        End If

        Return iReturn
    End Function
    Protected Function GetPlayerScores(ByVal paramDate As Date, ByVal paramTeamKey As Integer) As String
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sSQL As String
        Dim sResult As String = ""
        Dim sScore As String = ""
        Dim bFound As Boolean = False
        Dim sTemp As String = ""

        'get PlayerScores
        sSQL = "SELECT PScore_Name, PScore_Score " _
             + "FROM PlayerScores " _
             + "WHERE PScore_Team = " + paramTeamKey.ToString + " " _
             + "AND PScore_Date = " + FormatDateForDatabaseQuery(paramDate)
        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        myCommand.CommandText = sSQL
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            If myReader.Item(1) > 10 Then
                bFound = True
                sScore = " (" + myReader.Item(1).ToString + ")"
                sResult = sResult + myReader.Item(0).ToString + ", "
            End If
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()
        If sResult.Length > 3 Then
            sResult = sResult.Remove(sResult.Length - 2)
        End If
        sResult = sResult + sScore

        If Not bFound Then
            sResult = "No scores rcorded"
        End If

        Return sResult

    End Function

    Protected Function GetFixtureType(ByVal paramCup As Integer, paramRound As Integer) As String
        Dim sResult As String = ""

        Select Case paramCup
            Case 0
                sResult = "League"
            Case 1
                sResult = "Brinton (Round " + paramRound.ToString + ")"
            Case 2
                sResult = "Woodbine (Round " + paramRound.ToString + ")"
            Case 3
                sResult = "Glass (Round " + paramRound.ToString + ")"
            Case 4
                sResult = "Plate (Round " + paramRound.ToString + ")"
        End Select

        Return sResult
    End Function
    Protected Function GetTeamId(ByVal sTeamName As String) As Integer
        Dim iResult As Integer = 0
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sql As String

        If IsNothing(sTeamName) Then
            Accordion1.Visible = False
            Return iResult
        Else
            Accordion1.Visible = True
        End If

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        sql = "SELECT Pk_Team FROM Teams WHERE Team_Name = '" + sTeamName.ToString + "'"
        myCommand.CommandText = sql
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            iResult = myReader.Item(0)
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()
        Return iResult

    End Function
    Protected Function GetCompetitions(ByVal iCompetition As Integer, ByVal thisTeam As String) As Boolean
        Dim sResult As String = ""
        Dim AccessConnect As String = "Provider=Microsoft.Jet.OLEDB.4.0; data source=" + Server.MapPath("App_Data\LSM.mdb") + ";Jet OLEDB:Database Password=mg100dfx;"
        Dim conn As New OleDbConnection
        Dim myReader As OleDbDataReader
        Dim myCommand As New OleDbCommand
        Dim sql As String
        Dim bResult As Boolean = False
        Dim iCount As Integer = 0
        Dim iComp As Integer = iCompetition + 1

        conn.ConnectionString = AccessConnect
        conn.Open()
        myCommand.Connection = conn
        sql = "SELECT COUNT(*) FROM Fixtures WHERE Fixture_Cup = " + iComp.ToString + " " _
            + "AND (Fixture_HomeName = '" + thisTeam + "' " _
            + "OR   Fixture_AwayName = '" + thisTeam + "')"

        myCommand.CommandText = sql
        myReader = myCommand.ExecuteReader
        While myReader.Read()
            iCount = myReader.Item(0)
        End While
        myReader.Close()
        myReader = Nothing
        myCommand.Dispose()
        conn.Close()
        conn.Dispose()
        If iCount > 0 Then
            bResult = True
        End If
        Return bResult

    End Function
    Function FormatDateForDatabaseQuery(ByVal osDate As Date) As String
        Dim sDate As String
        Dim sMonth As String
        Dim sDay As String

        If Len(osDate.Month.ToString) = 1 Then
            sMonth = "0" + osDate.Month.ToString
        Else
            sMonth = osDate.Month.ToString
        End If
        If Len(osDate.Day.ToString) = 1 Then
            sDay = "0" + osDate.Day.ToString
        Else
            sDay = osDate.Day.ToString
        End If
        sDate = "#" + osDate.Year.ToString + "-" + sMonth + "-" + sDay + "#"
        Return sDate
    End Function
    Protected Function GetMonthText(ByVal iMonth As Integer) As String
        Dim sMonth As String

        Select Case iMonth
            Case 1
                sMonth = "Jan"
            Case 2
                sMonth = "Feb"
            Case 3
                sMonth = "Mar"
            Case 4
                sMonth = "Apr"
            Case 5
                sMonth = "May"
            Case 6
                sMonth = "Jun"
            Case 7
                sMonth = "Jul"
            Case 8
                sMonth = "Aug"
            Case 9
                sMonth = "Sep"
            Case 10
                sMonth = "Oct"
            Case 11
                sMonth = "Nov"
            Case 12
                sMonth = "Dec"
        End Select

        Return sMonth
    End Function


End Class